package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:安全感量表
 * @date 2021/7/20 15:55
 */
public class SQScale extends BaseScale{

    public SQScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {
        //得分
        int score = 0;
        //人际安全感因子得分
        int score1 = 0;
        //确定控制感因子得分
        int score2 = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (i == 0 || i == 2 || i == 5 || i == 7 || i == 9 || i == 11 || i == 14 || i == 15) {
                if (jsonObject1.getString("scoreDirection").equals("1")) {
                    if (jsonObject1.getString("checkItems").equals("非常符合")) {
                        score1 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("基本符合")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("中性或不确定")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("基本不符合")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("非常不符合")) {
                        score1 += 5;
                    }
                } else if (jsonObject1.getString("scoreDirection").equals("0")){
                    if (jsonObject1.getString("checkItems").equals("非常符合")) {
                        score1 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("基本符合")) {
                        score1 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("中性或不确定")) {
                        score1 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("基本不符合")) {
                        score1 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("非常不符合")) {
                        score1 += 1;
                    }
                }
            }else {
                if (jsonObject1.getString("scoreDirection").equals("1")) {
                    if (jsonObject1.getString("checkItems").equals("非常符合")) {
                        score2 += 1;
                    } else if (jsonObject1.getString("checkItems").equals("基本符合")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("中性或不确定")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("基本不符合")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("非常不符合")) {
                        score2 += 5;
                    }
                } else if (jsonObject1.getString("scoreDirection").equals("0")) {
                    if (jsonObject1.getString("checkItems").equals("非常符合")) {
                        score2 += 5;
                    } else if (jsonObject1.getString("checkItems").equals("基本符合")) {
                        score2 += 4;
                    } else if (jsonObject1.getString("checkItems").equals("中性或不确定")) {
                        score2 += 3;
                    } else if (jsonObject1.getString("checkItems").equals("基本不符合")) {
                        score2 += 2;
                    } else if (jsonObject1.getString("checkItems").equals("非常不符合")) {
                        score2 += 1;
                    }
                }
            }
        }
        score = score1 + score2;
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        resultMap.put("人际安全感因子得分", String.valueOf(score1));
        resultJson.put("人际安全感因子得分", String.valueOf(score1));
        resultMap.put("确定控制感因子得分", String.valueOf(score2));
        resultJson.put("确定控制感因子得分", String.valueOf(score2));

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",Constant.SHEET_NAME_SQ);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
